$(function () {
  var client = ZAFClient.init();
  client.invoke('resize', {width: '100%', height: '800px'});
  client.get('ticket.requester.id').then(
    function (data) {
      var user_id = data['ticket.requester.id'];
      requestUserInfo(client, user_id);
    }
  );
});

function showError(response) {
  var error_data = {
    'status': response.status,
    'statusText': response.statusText
  };
  var source = $("#error-template").html();
  var template = Handlebars.compile(source);
  var html = template(error_data);
  $("#visitor-session").html(html);
}

function showVisitorSession(requester_data) {
  var source = $("#visitor-session-template").html();
  var template = Handlebars.compile(source);
  var querystring = "";
  if (requester_data.user.email) {
    querystring = `email=${requester_data.user.email}`
  }
  if (requester_data.user.external_id) {
    if (querystring) {
      querystring = querystring.concat('&')
    }
    querystring = querystring.concat(`zendeskExternalId=${requester_data.user.external_id}`)
  }
  var html = template({
    'querystring': querystring
  });
  $("#visitor-session").html(html);
}

function requestUserInfo(client, id) {
  var settings = {
    url: '/api/v2/users/' + id + '.json',
    type: 'GET',
    dataType: 'json',
  };

  client.request(settings).then(
    function (data) {
      showVisitorSession(data)
    },
    function (response) {
      showError(response);
    }
  );
}
